/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */
dojo.provide("com.ibm.rational.cm.web._base.string");

dojo.require("dojo.i18n");

dojo.requireLocalization("com.ibm.rational.cm.web.ui", "common");

(function(){

var messages;
var cq = com.ibm.rational.cm.web;

dojo.mixin(cq, {
	
	getCommonString: function(){
		if(!messages){
			messages = dojo.i18n.getLocalization("com.ibm.rational.cm.web.ui", "common");
		}
		return messages;
	},

	sanitizeString: function(str){
		// 80453 - The !str condition returns true for empty strings.  Previously, code returned null for that case
		if(!str){ return str; }
		return str.replace(/&/gm, "&amp;").replace(/\"/gm, "&quot;").replace(/</gm, "&lt;").replace(/>/gm, "&gt;");
	},

	// Returns length of string that counts increments 2 for double byte characters
	getLength: function(str){
		if(!str){ return 0; }
		var len = 0;
		for(var i = 0, origLen = str.length; i < origLen; i++){
			if(escape(str.charAt(i)).length > 1){
				len += 2;
			}else{
				len += 1;
			}
		}
		return len;
	},
	
	substring: function(str, start, end){
		if(!str){ return ""; }
		var newStart, newEnd;
		var len = 0;
		var prevLen = 0;
		for(var i = 0, origLen = str.length; i < origLen; i++){
			prevLen = len;
			if(escape(str.charAt(i)).length > 1){
				len += 2;
			}else{
				len += 1;
			}
			if(!newStart && prevLen <= start && start < len){
				newStart = i;
			}
			if(end >= 0 && !newEnd && prevLen <= end && end < len){
				newEnd = i;
			}
			if(newStart >= 0){
				if(!end){
					break;
				}else if(newEnd >= 0){
					break;
				}
			}
		}
		if(newStart != null){
			return str.substring(newStart, newEnd);
		}else{
			return "";
		}
	},
	
	getAbbreviatedString: function(str, maxLen){
		if(cq.getLength(str) > maxLen){
			return cq.substring(str, 0, maxLen) + "...";
		}else{
			return str;
		}
	}
});

})();