/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.ProjectAreaListPage"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dojox.data.dom"); //$NON-NLS-1$
	dojo.require("dojo.cookie"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
	dojo.require("jazz.app.ResourceLink");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.client.init.InitializationData"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants");//$NON-NLS-1$ 
	dojo.requireLocalization("com.ibm.team.process.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var InitializationData = com.ibm.team.repository.web.client.init.InitializationData;
	var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var ResourceLink = jazz.app.ResourceLink;
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants; 
		
	var MANAGE_PROJECT_AREAS_ACTION_URI = "#action=jazz.viewPage&id=com.ibm.team.process.ProjectAreaManagement"; //$NON-NLS-1$
	var SHOWARCHIVED_COOKIE = "JazzProjectsShowArchived"; //$NON-NLS-1$
	dojo.declare("com.ibm.team.process.web.ui.internal.ProjectAreaListPage", //$NON-NLS-1$
 [dijit._Widget, dijit._Templated], {
	
		templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/templates/ProjectAreaListPage.html"), //$NON-NLS-1$ //$NON-NLS-2$
		constructor: function(){
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this._manageHref = net.jazz.ajax._contextRoot + "/admin" + MANAGE_PROJECT_AREAS_ACTION_URI; //$NON-NLS-1$
		},
		
		postCreate: function(){
			var ActionRegistry = net.jazz.ajax.ui.PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction("com.ibm.team.process.web._listProjects", this, "_runDefaultAction"); //$NON-NLS-1$ //$NON-NLS-2$
			var link = document.createElement("a"); //$NON-NLS-1$
			link.href = this._manageHref;
			link.appendChild(document.createTextNode(this.messages.ProjectAreaListPage_2));
			
			this.manageLink.appendChild(document.createTextNode(this.messages.ProjectAreaListPage_1));
			this.manageLink.appendChild(link);
			this.manageLink.appendChild(document.createTextNode(this.messages.ProjectAreaListPage_3));
		},
		
		_runDefaultAction: function(){
			dojo.addClass(this.noProjectAreasMessage, "hidden"); //$NON-NLS-1$
			dojox.data.dom.removeChildren(this.myProjects);
			dojox.data.dom.removeChildren(this.otherProjects);
			dojox.data.dom.removeChildren(this.archivedProjects);
			
			var authContrib = getAuthenticatedContributor();
			var authContribId;
			if (authContrib != null) {
				authContribId = authContrib.userId;
			}
			var srh = new ServiceResponseHandler(this, "populateProjectAreas", "handleError"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.getAllProjectAreas(srh, {
				userId: authContribId
			});
		},
		
		showNoProjectAreasMessage: function(showMessage){
			if (showMessage) {
				dojo.removeClass(this.noProjectAreasMessage, "hidden"); //$NON-NLS-1$
				var permissionInitializer = InitializationData.get("com.ibm.team.repository.service.canGrantPermissionInitializer"); //$NON-NLS-1$
				if (permissionInitializer != null && permissionInitializer.canGrantPermission) {
					dojo.removeClass(this.adminLinkArea, "hidden"); //$NON-NLS-1$
					dojo.removeClass(this.manageLink, "hidden"); //$NON-NLS-1$
					dojo.addClass(this.adminContact, "hidden"); //$NON-NLS-1$
				} else {
					dojo.addClass(this.adminLinkArea, "hidden"); //$NON-NLS-1$
					dojo.addClass(this.manageLink, "hidden"); //$NON-NLS-1$
					dojo.removeClass(this.adminContact, "hidden"); //$NON-NLS-1$
				}
			} else {
				dojo.addClass(this.noProjectAreasMessage, "hidden"); //$NON-NLS-1$
			}
		},
		
		populateProjectAreas: function(projectAreas){
			if (projectAreas) {
				projectAreas = projectAreas.sort(function(a, b){
					return a.name > b.name ? 1 : a.name < b.name ? -1 : 0;
				});
				var myProjects = [];
				var archivedProjects = [];
				for (var i = 0; i < projectAreas.length; i++) {
					if (projectAreas[i].archived) {
						archivedProjects.push(projectAreas[i]);
						projectAreas.splice(i, 1);
						i--;
					} else if (projectAreas[i].myProjectArea) {
						myProjects.push(projectAreas[i]);
						projectAreas.splice(i, 1);
						i--;
					}
				}
			}
			
			var showNoProjectsMessage = true;
			if (projectAreas && (projectAreas.length != 0 || archivedProjects.length != 0 || myProjects.length != 0)) {
				if (myProjects.length > 0) {
					this.populateArea(this.myProjects, myProjects);
					showNoProjectsMessage = false;
				} else {
					dojo.addClass(this.myProjects.parentNode, "hidden"); //$NON-NLS-1$
				}
				
				if (projectAreas && projectAreas.length > 0) {
					this.populateArea(this.otherProjects, projectAreas);
					showNoProjectsMessage = false;
				} else {
					dojo.addClass(this.otherProjects.parentNode, "hidden"); //$NON-NLS-1$
				}
				
				if (archivedProjects.length > 0) {
					dojo.removeClass(this.filterArea, "hidden"); //$NON-NLS-1$
					var storedPref = dojo.cookie(SHOWARCHIVED_COOKIE);
					if (storedPref) {
						showNoProjectsMessage = false;
						this.showArchivedCheckbox.checked = "checked"; //$NON-NLS-1$
						this.populateArea(this.archivedProjects, archivedProjects, false);
					} else {
						this.showArchivedCheckbox.checked = null;
						this.populateArea(this.archivedProjects, archivedProjects, true);
					}
				}
			}
			this.showNoProjectAreasMessage(showNoProjectsMessage);
		},
		_onCheckboxChange: function(event){
			if (event.target.checked) {
				dojo.cookie(SHOWARCHIVED_COOKIE, "checked", { //$NON-NLS-1$
					expires: 365
				});
				dojo.removeClass(this.archivedProjectsSection, "hidden"); //$NON-NLS-1$
				if (dojo.hasClass(this.otherProjects.parentNode, "hidden") && dojo.hasClass(this.myProjects.parentNode, "hidden")) { //$NON-NLS-1$ //$NON-NLS-2$
					dojo.addClass(this.noProjectAreasMessage, "hidden"); //$NON-NLS-1$
				}
			} else {
				dojo.cookie(SHOWARCHIVED_COOKIE, ""); //$NON-NLS-1$
				dojo.addClass(this.archivedProjectsSection, "hidden"); //$NON-NLS-1$
				if (dojo.hasClass(this.otherProjects.parentNode, "hidden") && dojo.hasClass(this.myProjects.parentNode, "hidden")) { //$NON-NLS-1$ //$NON-NLS-2$
					dojo.removeClass(this.noProjectAreasMessage, "hidden"); //$NON-NLS-1$
				}
			}
		},
		populateArea: function(area, data, hide){
			if (area && area.parentNode) {
				if (!hide && area.parentNode) {
					dojo.removeClass(area.parentNode, "hidden"); //$NON-NLS-1$
				} else {
					dojo.addClass(area.parentNode, "hidden"); //$NON-NLS-1$
				}
			}
			var curUrl = new dojo._Url(location.href);
			
			if (curUrl.query) { //check for debug mode
				var urlSuffix = "?" + curUrl.query; //$NON-NLS-1$
			} else {
				urlSuffix = ""; //$NON-NLS-1$
			}
			
			for (var i = 0; i < data.length; i++) {
				area.appendChild(this.createProjectAreaRow(data[i].name, data[i].summary, data[i].description, data[i].itemId, urlSuffix));
			}
		},
		handleError: function(err){
			dojox.data.dom.removeChildren(this.projectAreaList);
			this.displayErrorMessage(dojo.string.substitute(this.messages.ProjectAreaListPage_4, [err]));
		},
		displayErrorMessage: function(msg){
			this.displayMessage(msg, "errorMsg"); //$NON-NLS-1$
		},
		displayMessage: function(msg, cssClass){
			dojox.data.dom.removeChildren(this.messageBox);
			this.messageBox.className = cssClass;
			this.messageBox.appendChild(document.createTextNode(msg));
		},
        createProjectAreaRow: function(projectAreaName, projectAreaSummary, projectAreaDetails, projectAreaId, urlSuffix){
        	var row = document.createElement("div"); //$NON-NLS-1$
        	row.className = "project"; //$NON-NLS-1$
        	// create project area link
        	var linkArea = document.createElement("h3"); //$NON-NLS-1$
        	var link = document.createElement("a"); //$NON-NLS-1$
        	link.appendChild(document.createTextNode(projectAreaName));
        	linkArea.appendChild(link);
        	var encodedName = encodeURIComponent(projectAreaName);

        	link.href = this.getProjectAreaUrl(projectAreaId);        	
        	var rl = new ResourceLink({
        		'presentationUri': net.jazz.ajax._contextRoot + "/web/projects/" + encodedName + urlSuffix //$NON-NLS-1$ //$NON-NLS-2$
        	}, link);
        	row.appendChild(linkArea);
        	
        	if (projectAreaSummary) {
        		row.appendChild(document.createTextNode(projectAreaSummary));
        	}
        	if (projectAreaSummary && projectAreaDetails) {
        		row.appendChild(document.createElement("br")); //$NON-NLS-1$
        		row.appendChild(document.createElement("br")); //$NON-NLS-1$
        	}
        	if (projectAreaDetails) {
        		var lines = projectAreaDetails.split(/\n/);
        		for (var i = 0; i < lines.length; i++) {
        			if (i > 0) {
        				row.appendChild(document.createElement("br")); //$NON-NLS-1$
        			}
        			row.appendChild(document.createTextNode(lines[i]));
        		}
        	}
        	
        	return row;
        }, 
		
		getProjectAreaUrl: function(projectAreaItemId){	
			var location = new String(document.location);
			var path = location.split("/");//$NON-NLS-1$
			var serverAddress;
			if (path.length > 0) {
				serverAddress = path.shift() + "//";//$NON-NLS-1$
				path.shift(); //empty from the double //
				serverAddress = serverAddress + path.shift();
			}
			return serverAddress + net.jazz.ajax._contextRoot + "/process/project-areas/" + projectAreaItemId; //$NON-NLS-1$ //$NON-NLS-2$
		}
	});
	
})();
