﻿/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 
class HorizontalBarYAxis extends YAxis {

	public static var MAX_TEXT_FIELD_WIDTH_RATIO:Number = 0.25;
	
	
	public function HorizontalBarYAxis() {
		super();
	}	

	public function draw(parentMC:MovieClip, gridData:GridData):Void {
	
		super.draw(parentMC, gridData);
		
		this.mc.lineStyle(Axis.LINE_THICKNESS, Axis.LINE_COLOUR);		
		
		this.mc.moveTo(this.gridData.xZeroPosition, this.gridData.startY);
		this.mc.lineTo(this.gridData.xZeroPosition, this.gridData.yZeroPosition);
		
		var textFieldWidth:Number = this.gridData.yAxisMaxLabelWidth + (Constants.TEXT_FIELD_MARGIN * 2);
		
		var model:ChartModel = ChartEngine.getInstance().getModel();
		
		for (var step:Number = 0; step < this.gridData.yAxisSectionCount; step++) {
			// Label
			var labelID:String = YAxis.Y_AXIS_LABEL_NAME + step;
			var label:String = model.parameterNames[step];
			
			this.mc.createTextField(labelID, 
									this.mc.getNextHighestDepth(), 
									this.gridData.startX, 
									this._getLabelLocationY(step, label), 
									textFieldWidth, 
									Axis.TEXT_FIELD_HEIGHT);
			this.mc[labelID].text = TextUtility.truncateAndTrailOffText(label, YAxis.LABEL_FORMAT, this.mc[labelID]._width);
			this.mc[labelID].setTextFormat(YAxis.LABEL_FORMAT);
		}				
		
	}	
	
	private function _getLabelLocationY(step:Number, text:String):Number {
		var spacing:Number = this.gridData.yAxisSpacing;
		var textFieldHeight:Number = YAxis.LABEL_FORMAT.getTextExtent(text).textFieldHeight;
		var locationY:Number = this.gridData.startY + (step * spacing);
		
		if (spacing < textFieldHeight) {
			// Problem: The number of parameters exceeds the available graph area height
			// Labels will be displaced and overlap
			// TODO: Fix
		} else {
			// Vertically center label within the allocated Y-axis space
			locationY = locationY + ((spacing - textFieldHeight) / 2);
		}
		
		return locationY;
	}
	
	public function destroy():Void {
		super.destroy();
	}	
	
}
