/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.users.model.AbsencesModel"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$

(function() {
	
var Assert			= com.ibm.team.apt.web.ui.internal.common.Assert;

dojo.declare("com.ibm.team.apt.web.ui.internal.users.model.AbsencesModel", //$NON-NLS-1$
			 [], {
	
	__absences: null,
	__addedAbsences: null,
	__removedAbsences: null,
	__modifiedAbsences: null,
	__listeners: null,
	
	constructor: function(absences) {
		this.__absences= absences;
		
		for ( var i = 0; i < this.__absences.length; i++) {
			this.__absences[i]._model= this;
		}
		
		this.__addedAbsences= new Array();
		this.__removedAbsences= new Array();
		this.__modifiedAbsences= new Array();
		this.__listeners= new Array();
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getAbsences: function() {
		return this.__absences;
	},
	
	getDeletedAbsences: function() {
		return this.__removedAbsences;
	},
	
	getAddedAbsences: function() {
		return this.__addedAbsences;
	},
	
	getModifiedAbsences: function() {
		return this.__modifiedAbsences;
	},
	
	removeAbsence: function(absence) {
		if (absence.isDraft) {
			this.__addedAbsences= dojo.filter(this.__addedAbsences, function(element) {return element.itemId != absence.itemId});
		} else {
			this.__removedAbsences.push(absence);
		}
		
		this.__absences= dojo.filter(this.__absences, function(element) {return element.itemId != absence.itemId});
		this.__notifyListeners();
	},
	
	addAbsence: function(absence) {
		Assert.isLegal(absence.isDraft, "Absence must be a draft"); //$NON-NLS-1$
		Assert.isLegal(absence.model == null, "Absence must only be added once"); //$NON-NLS-1$
		
		absence._model= this;
		
		this.__addedAbsences.push(absence);
		this.__absences.push(absence);
		this.__notifyListeners();
	},
	
	markModified: function(absence) {
		if (!absence.isDraft && dojo.indexOf(this.__modifiedAbsences, absence) < 0) {
			this.__modifiedAbsences.push(absence);
		}
		
		this.__notifyListeners();
	},
	
	addModelListener: function(listener) {
		this.__listeners.push(listener);
	},
	
	// ---- spi ------------------------------------------------------------------------------------------------------------
	
	// ---- implementation -------------------------------------------------------------------------------------------------
	
	__notifyListeners: function() {
		for ( var i = 0; i < this.__listeners.length; i++) {
			this.__listeners[i](this);
		}
	},

	__sentinel: null // terminates this class definition
});

})();
