/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.QuickInformationPart");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("jazz.ui.HoverPopup");
dojo.require("jazz.app.ResourceLink");
dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.ImagePool");
dojo.require("jazz.ui.ImagePreview");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
/*
 * This is a wrapper widget that shows the Approvals Section
 */
(function(){
	var EventTopics= com.ibm.team.workitem.web.ui.internal.page.EventTopics;
	var WorkItemUtil = com.ibm.team.workitem.web.client.util;
    var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
    var EditorUtil = com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;
    var ImagePool = com.ibm.team.workitem.web.ui.internal.view.common.ImagePool;
    var ImagePreview = jazz.ui.ImagePreview;
	var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
	var ServiceResponseHandler	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var WorkItemClient			= com.ibm.team.workitem.web.client.internal.WorkItemClient;
    
var DOWNLOAD_SERVICE_URI = "com.ibm.team.workitem.service.internal.rest.IAttachmentRestService/repo/csid/Attachment/";
var ATTACHMENT_ID= "com.ibm.team.workitem.linktype.attachment";

    /* defineWidget */
    dojo.declare("com.ibm.team.workitem.web.ui.internal.view.editor.parts.QuickInformationPart", [dijit._Widget, dijit._Templated], {
    
        templateString: '<div class="QuickInformationPart SectionPart">' +
        '<span dojoAttachPoint="_sectionMenuSPAN"></span>' +
        '<div dojoAttachPoint="_contentNode">' +
        '</div>' +
        '<BR dojoAttachPoint="_endBR"></div>',
        constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
		},	
        postCreate: function(){
			if(dojo.isIE) {
				this._endBR.style.display = "none";
			}
            this._childWidgets = [];

            this._isInitialized = false;
            this._workItem = this.parentController.workingCopy.object;
			if(this.sectionLayout) {
	            this.sectionLayout.setBackgroundClassName("QuickInformationBackground");	
			}

			this.workingCopy.addListener({
				path: ["attributes", "internalSubscriptions" ],
				event: "onchange",
				listener: this,
				functionName: "_workItemChanged"
			});				
			this.workingCopy.addListener({
				path: ["linkTypes"],
				event: "onchange",
				listener: this,
				functionName: "_workItemChanged"
			});				
			this.workingCopy.addListener({
				path: ["approvals"],
				event: "onchange",
				listener: this,
				functionName: "_workItemChanged"
			});				

			
			this._fetchQuickInformation();

        },
        destroyWidget: function(){
			this.resetWidget();
			if(this.workingCopy) this.workingCopy.removeAllListeners({listener: this});
			this.destroy();
		},
		getDefaultLabel: function() {
			return this.messages.labelQuickInformation;
		},
		_workItemChanged: function() {
				this.refresh();
		},
        resetWidget: function(){

            for (var i = 0; i < this._childWidgets.length; i++) {
                if (this._childWidgets[i].destroyWidget) {
					this._childWidgets[i].destroyWidget()
				}
				else {
					if (this._childWidgets[i].destroy) {
						this._childWidgets[i].destroy()
					}
				}
				
                this._childWidgets[i] = null;
            }
            
            this._childWidgets = [];
            dojox.data.dom.removeChildren(this._contentNode);
			
        },
        /*
         * Load the tab when it is shown
         */
        showWidget: function(){

        },
		_showLoading: function(isLoading) {
			
		},
		_showEmpty: function(isEmpty) {
//			if(isEmpty) {
//				this.domNode.style.display="none";
//			} else {
//				this.domNode.style.display="";
//			}
		},
        _fetchQuickInformation: function() {
			if(!this._modifiers.quickinformationConfiguration && this.sectionLayout && this.sectionLayout.domNode) {
				this.sectionLayout.domNode.style.display = "none";
				this._showLoading(false);
				this._showEmpty(true);
				return;
			}
			
			
			var self = this;
			var serviceObj= {
				success: function(qiPres) {
					if(self.parentController && self.parentController.isDestroyed) return;
					self._showLoading(false);
            		self.refresh(qiPres);
				},
				failure: function(errorObj) {
					if(self.parentController && self.parentController.isDestroyed) return;
					self._showLoading(false);
					self._showEmpty(true);
					alert(self.messages.errorLoadingQuickInformation);
					console.debug(self.messages.errorLoadingQuickInformation + " " + errorObj.message);
				}
			};
			var srh= new ServiceResponseHandler(serviceObj, "success", "failure");
			var args = { configurationId:this._modifiers.quickinformationConfiguration  || "com.ibm.team.workitem.configuration.quickinformation.default"};
			args.projectAreaItemId = this.workingCopy.getProjectAreaItemId();
			WorkItemClient.getQuickInformationPresentation(srh, args);
		},
        /*
         * Setup the page and read the states and types
         */
        refresh: function(qiPres){
			if(qiPres) {
				this.presentation = qiPres;
			}
			if(!this.presentation) return;
			qiPres = this.presentation;
            this.resetWidget();
            this._markDirtyIfDifferent();
            
			var sectionNode = this._contentNode;
			var sectionLayout = this.sectionLayout;
//            try {
                var self = this;
                var summaryLinks = document.createElement("ul");
                summaryLinks.className = "SummaryListElement";
                sectionNode.appendChild(summaryLinks);
                
                var listObjects = [];
                
				if(this.sectionLayout) {
				      sectionLayout.setBorder(true);	
				}
                var linkTypeMap = {};

				var linkTypes = this._workItem.linkTypes || [];
				var id;
				for (var i = 0; i < linkTypes.length; i++) {
					id = linkTypes[i].id.replace(/\./g,"_");
					if(linkTypes[i].isSource || linkTypes[i].isSymmetric){
						id = id+"_source";
					}
					linkTypeMap[id] = linkTypes[i];
					linkTypes[i]._wasShown = false; // reset so shown again
				}
				
				var linkTypeId;
				for (var i = 0; i < qiPres.length; i++) {
					linkTypeId = qiPres[i].linkTypeId;
					if (linkTypeId) {
						linkTypeId = linkTypeId.replace(/\./g, "_");
						// related doesn't match in linkDTO and qiPres
						if (qiPres[i].isSourceLink) {
							linkTypeId = linkTypeId + "_source";
						}
					}
					if (linkTypeId) {
						if(linkTypeMap[linkTypeId] && !linkTypeMap[linkTypeId]._wasShown) {
							linkTypeMap[linkTypeId]._wasShown = true;
							this.showLinkTypePresentation(listObjects, qiPres[i], linkTypeMap[linkTypeId]);
						}
					}
					else {
						if (qiPres[i].targetPartId == "com.ibm.team.workitem.attribute.subscriptions") {
							this.showSubscriptionPresentation(listObjects, qiPres[i], linkTypeMap[linkTypeId]);
						}
						else {
							if (qiPres[i].targetPartId == "com.ibm.team.workitem.presentation.approvals") {
								this.showApprovalPresentation(listObjects, qiPres[i], linkTypeMap["com_ibm_team_workitem_linktype_approvals"]);
							}
							else {
								if (qiPres[i].targetPartId == "com.ibm.team.workitem.presentation.attachments") {
									this.showAttachmentPresentation(listObjects, qiPres[i], linkTypeMap["com_ibm_team_workitem_linktype_attachment"]);
								}
							}
						}
					}
				}
                                
                if (listObjects.length == 0) {
                    var noLinks = document.createElement("li");
                    noLinks.className = "NoLinks";
                    noLinks.appendChild(document.createTextNode(this.messages.labelNoLinks));
                    summaryLinks.appendChild(noLinks);
                }
                else {
                    for (var i = 0; i < listObjects.length; i++) {
                        var li = this.getListElement(listObjects[i]);
                        summaryLinks.appendChild(li);
                    }
                }
				// Add an invisible item to the end to force the box to contain the lists
				if (!dojo.isIE) {
					var end = document.createElement("li");
					end.className = "SummaryListElementItem";
					var hr = document.createElement("hr");
					hr.style.visibility = "hidden";
					hr.style.marginBottom = "-1.3em";
					end.appendChild(hr);
					summaryLinks.appendChild(end);
				}
//            } 
//            catch (e) {
//                console.debug("Error loading quick information: " + e.message + "\n" + (e.stack ? e.stack : ""));
//            }
            
        },
		showLinkTypePresentation: function(listObjects, qiPres, linkType) {
            var listObjectToUpdate = null;
            listObjectToUpdate = {
                    label: qiPres.title || linkType.displayName,
                    id: linkType.id,
                    count: 0,
                    itemList: [],
                    toString: function(){
                        return this.label;
                    }
                }

			var itemCount = 0;
            for (var j = 0; j < linkType.linkDTOs.length; j++) {
				var linkDTO = linkType.linkDTOs[j];
				if(linkDTO._isDeleted) continue;
				var attr = this._getTargetAttr(linkDTO);
				if (attr.id) { // a work item
				    itemCount++;
					this._addWorkItem(linkDTO, listObjectToUpdate, attr);
				}
				else 
					if (linkDTO.comment) {
				    	itemCount++;
						listObjectToUpdate.itemList.push({
							id: 0,
							summary: linkDTO.comment
						})
					}
				
				listObjectToUpdate.itemList.sort(function(x, y){
					try {
						return x.id - y.id
					} 
					catch (e) {
						return 0;
					}
				});
			}
            listObjectToUpdate.count += itemCount;
			if(listObjectToUpdate.count > 0 ) {
			     listObjects.push(listObjectToUpdate);
			}
		},

		showSubscriptionPresentation: function(listObjects, qiPres, linkType) {
          if (this._workItem.attributes && this._workItem.attributes.internalSubscriptions && this._workItem.attributes.internalSubscriptions.items) {
           	this._addSubscriptions(listObjects, qiPres);
          }
		},
		showApprovalPresentation: function(listObjects, qiPres, linkType) {
          if (this._workItem.approvals) {
			this._addApprovals(listObjects);
          }
		},
		showAttachmentPresentation: function(listObjects, qiPres, linkType) {
			if(!linkType || !linkType.linkDTOs || linkType.linkDTOs.length==0) return;
            var itemList = [];
			var count = 0;
            for (var k = 0; k < linkType.linkDTOs.length; k++) {
               if(this._addAttachment(itemList,linkType.linkDTOs[k] )) count++;
            }
            
            itemList.sort(function(x, y){
                if (!x || !y || x.id == null || y.id == null) 
                    return 0;
                return x.id < y.id ? -1 : 1
            });
			if(itemList.length == 0) return;
            listObjects.unshift({
                label: qiPres.title || this.messages.labelAttachments,
                id: "attachments",
                count: count,
                itemList: itemList
            });
		},
		_addAttachment: function(itemList, linkDTO) {
			if(!linkDTO || linkDTO.isRemoved) return false;
			  if (linkDTO.comment) { // attachment
						var href = TeamServerClient._getServicePrefix() + DOWNLOAD_SERVICE_URI + linkDTO.itemId;
						var id = 0;
						if (linkDTO && linkDTO.target && linkDTO.target.id) {
							id = linkDTO.target.id;
						}
						if (id) {
							var fileName = linkDTO.comment
							var index = fileName.lastIndexOf(".");
							var previewParms = false;
							var ext = index == -1 ? null : fileName.substring(index + 1);
							ext = ext ? ext.toLowerCase() : ext;
							if (ext == "gif" || ext == "png" || ext == "jpeg" || ext == "jpg") {
								var previewParms = {
									src: href,
									filename: fileName
								}
							}
							
							itemList.push({
								shortName: "" + id,
								id: id,
								summary: id + ": " + linkDTO.comment,
								href: href,
								newWindow: true,
								previewParms: previewParms
							});
						}
						else {
							itemList.push({
								id: 0,
								summary: linkDTO.comment,
								newWindow: true,
								href: href
							});
						}
					}
					return true;
		}, 
		_getTargetAttr : function(linkDTO) {
				if(!linkDTO) return;
				var id = false;
				var stateGroup = -1;
				if (linkDTO.target && linkDTO.target.attributes) {
					for (var i = 0; i < linkDTO.target.attributes.length; i++) {
						if (linkDTO.target.attributes[i].key == "id") {
							id = linkDTO.target.attributes[i].value.id;
							break;
						}
					}
					for (var i = 0; i < linkDTO.target.attributes.length; i++) {
						if (linkDTO.target.attributes[i].key == "stateGroup") {
							stateGroup = linkDTO.target.attributes[i].value.id;
							break;
						}
					}
				}
				return { id: id, stateGroup: stateGroup };
		},
		_addWorkItem: function(linkDTO, listObjectToUpdate, attr) {
			if(!linkDTO) return;
            var linkName = linkDTO.comment;
            if (linkDTO.target && linkDTO.target._eQualifiedClassName && linkDTO.target._eQualifiedClassName.indexOf("WorkItemLinkDTO") != -1 && linkName.indexOf("<") == 0) {
                var newId = attr.id + ":";
                linkName = linkName.replace(/<.*>:/, newId);
            }
            if (linkName.indexOf("#") == 0 && linkName.length > 1) {
                linkName = linkName.substring(1, linkName.length);
            }
            listObjectToUpdate.itemList.push({
				shortName: "" + attr.id,
                id: attr.id,
				stateGroup: attr.stateGroup,
                summary: linkName,
                resourceLinkUri: linkDTO.url
            })
		}, 
		_addSubscriptions: function(listObjects, qiPres) {
            var itemList = [];
            var subItems = this.workingCopy.getItems({ attributeId: "internalSubscriptions", skipDeleted: true });
			if(subItems.length == 0) return;
			var split, shortName;
            for (var k = 0; k < subItems.length; k++) {
                var item = {};
                item.summary = subItems[k].name;
				var emailSubject;
				if(this.parentController && this.parentController.workingCopy) {
					try {
						emailSubject =  this.parentController.workingCopy.object.attributes.workItemType.label + " " + this.parentController.workingCopy.getId() + ": " + EditorUtil.restoreTags(this.parentController.workingCopy.object.attributes.summary.content);
					}	catch(e) {} // ignore;			
				}
				item.href = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil._getMailto(subItems[k].emailAddress, emailSubject); // subject can be null
				split = item.summary.split(" ");
				shortName = "";
				for(var m=0;m<split.length;m++) {
					shortName += split[m].substring(0,1).toUpperCase();
				}
				item.shortName = shortName;
				var userIdText = "";
				if(subItems[k].userId) {
					userIdText = " (@" + subItems[k].userId + ")";
				}
				item.summary = item.summary  + userIdText;
                itemList.push(item);
            }
            
            itemList.sort(function(x, y){
                if (!x || !y || !x.summary || !y.summary) 
                    return 0;
                return x.summary < y.summary ? -1 : 1
            });
            listObjects.unshift({
                label: qiPres.title || this.messages.labelSubscriptions,
                id: "subscriptions",
                count: subItems.length,
                itemList: itemList
            });
		},
		_addApprovals: function(listObjects) {
            var itemList = [];
            for (var k = 0; k < this._workItem.approvals.length; k++) {
                var item = {};
                if (this._workItem.approvals[k].cumulativeState && !this._workItem.approvals[k]._isDeleted) {
                    var status = "";
                    var split = this._workItem.approvals[k].cumulativeState.split(".");
                    if (split) {
                        var status = " - " + split[split.length - 1];
                    }
                    item.summary = this._workItem.approvals[k].name + status; 
                    itemList.push(item);
                }
            }
            
            itemList.sort(function(x, y){
                if (!x || !y || !x.summary || !y.summary) 
                    return 0;
                return x.summary < y.summary ? -1 : 1
            });
			if(itemList.length == 0) return;
            listObjects.unshift({
                label: this.messages.labelApprovals,
                id: "approvals",
                count: itemList.length,
                itemList: itemList
            });
		},
		getListElement: function(linkType) {
				var li= document.createElement("li");
				li.className = "SummaryListElementItem";
				var tabLink= document.createElement("a");
				var tabName= "links";
				tabName= (linkType.id === "approvals") ? "approvals" : tabName;
//				tabName= (linkType.id === "subscriptions") ? "subscriptions" : tabName;
//				tabName= (linkType.id === "com.ibm.team.workitem.linktype.attachment") ? "attachments" : tabName;
//				tabName = this.parentController.getTabNameForType(tabName);

				tabLink.href= EditorUtil._getUriForTab(tabName, this.parentController.getUrl());
				
				// Truncate long names
				if(linkType.label.length > 30) {
					linkType.label=linkType.label.substr(0,27) + "...";
				}
				
				var label= linkType.label + " (" + linkType.count + ")"
				
				var self=this;
				this.connect(tabLink, "onclick",
					function(e) {
						if (window.location.href.indexOf("_ajax-modules") > 0) {
							dojo.stopEvent(e);
							return;
						}
						self._handleSummaryItemClick(e);
					});
	
	
				for (var k=0; k<linkType.itemList.length; k++) {
					try {
					if(linkType.itemList[k].id != null && linkType.itemList[k].id == 0) {
						// lets see if we can derive the id from the summary
						var summary = linkType.itemList[k].summary;
						if(summary) {
							var m = summary.indexOf(": ");
							if(m != -1) {
								var idString = summary.substring(0,m);
								if(idString && idString.indexOf(" ")) {
									var split = idString.split(" ");
									var idValue = 0;
									idValue = split[split.length-1];
									try{
										idValue = parseInt(idValue);
										linkType.itemList[k].id = idValue;
									} catch(e) {}; // ignore if not a number
									
								}
							}
						}
					}
					} catch(e) {}; // ignore  problem here
					if(!linkType.itemList[k].href && linkType.itemList[k].id) {
						linkType.itemList[k].href= WorkItemUtil.getViewWorkItemUri(linkType.itemList[k].id);
					}
				}
				
				var itemList = document.createElement("ul");
				itemList.className = "QuickInformationList";
				var anchor, nameLi, headerLi, ext, previewParms, itemCount = 0;
				headerLi = document.createElement("li");
				headerLi.className = "QuickInformationListItem";

					
				headerLi.appendChild(tabLink)
				itemList.appendChild(headerLi);
				var tipSpan = document.createElement("span");
				var innerSpan = document.createElement("span");
				innerSpan.className = "com-ibm-team-workitem-quickinfo";
				tipSpan.appendChild(innerSpan);
				label = WorkItemUtil.plainToHTML(label); // remove scripts
				innerSpan.innerHTML += "<div class=\"heading\">" + label + "</div>"; // innerHTML OK
				for (var i = 0; i < linkType.itemList.length; i++) {
					if(!linkType.itemList[i].summary) continue;
					linkType.itemList[i].safeSummary = WorkItemUtil.plainToHTML(linkType.itemList[i].summary); // remove scripts
					linkType.itemList[i].safeHref = EditorUtil.removeHrefScripting(linkType.itemList[i].href); // remove scripts

					if(linkType.itemList[i].href) {
						if(linkType.itemList[i].shortName && itemCount < 10) {
							itemCount++;
							if (!this._isAjaxModule()) {
								anchor = document.createElement("A");
								anchor.appendChild(document.createTextNode(linkType.itemList[i].shortName));
								anchor.href = linkType.itemList[i].href;
								if (linkType.itemList[i].newWindow) {
									anchor.target = "_blank";
								}
								if (linkType.itemList[i].stateGroup == 2) {
									dojo.addClass(anchor, "Closed");
								}
							} else { // non module
							    anchor = document.createElement("span");
								anchor.appendChild(document.createTextNode(linkType.itemList[i].shortName));
								if (linkType.itemList[i].stateGroup == 2) {
									dojo.addClass(anchor, "Closed");
								}
							}
							nameLi = document.createElement("LI");
							nameLi.className = "QuickInformationListItem";

							nameLi.appendChild(anchor);
							if(i<linkType.itemList.length -1 ) {
									nameLi.appendChild(document.createTextNode(", "));
							}
							itemList.appendChild(nameLi);
							if(linkType.itemList[i].previewParms) {
								previewParms = linkType.itemList[i].previewParms;
								previewParms.around = [ anchor ];
								new ImagePreview(previewParms, document.createElement("div"));
							} else {
								anchor.title = linkType.itemList[i].summary;
							}
							
							var currentEntry= linkType.itemList[i];
							if (currentEntry.resourceLinkUri && !this._isAjaxModule()) {
								var resourceLinkArgs= { 
									retainLinkText: true,
									uri: currentEntry.resourceLinkUri,
									presentationUri: currentEntry.href,
									label: currentEntry.shortName
								};
								this.workingCopy.applyResourceLinkToAnchor(resourceLinkArgs, anchor);
							}
						}
						if(itemCount ==10 && linkType.itemList.length> 10) {
							itemCount ++;
							anchor=document.createElement("A");
							anchor.appendChild(document.createTextNode("..."));
							anchor.title = this.messages.labelMore;
							anchor.href = tabLink.href;
							nameLi = document.createElement("LI");
//							nameLi.className = "QuickInformationListItemLast";
							nameLi.className = "QuickInformationListItem";
							nameLi.appendChild(anchor);
							itemList.appendChild(nameLi);
						}
						
						if (!this._isAjaxModule()) {
							var target = "";
							if(linkType.itemList[i].newWindow) {
								target = " target=\"_blank\"";
							}
							if (linkType.itemList[i].stateGroup == 2) {
								innerSpan.innerHTML += "<div class='com-ibm-team-workitem-Strikeout'><a" + target + " href=\"" + linkType.itemList[i].safeHref + "\">" + linkType.itemList[i].safeSummary + "</a></div>";
							}
							else {
								innerSpan.innerHTML += "<div><a" + target + " href=\"" + linkType.itemList[i].safeHref + "\">" + linkType.itemList[i].safeSummary + "</a></div>";
							}
						} else {
								innerSpan.innerHTML += "<div>" + linkType.itemList[i].safeSummary + "</div>";
						}
							
					} else {
						innerSpan.innerHTML += "<div>"+linkType.itemList[i].safeSummary + "</div>";
					}
				}
				if(itemCount ==0) {
					headerLi.className = "QuickInformationListItemLast";
					tabLink.appendChild(document.createTextNode(label));
				} else {
					tabLink.appendChild(document.createTextNode(label + ": "));
					nameLi = document.createElement("LI");
					nameLi.className = "QuickInformationListItemLast";
					nameLi.appendChild(document.createTextNode(" "));
					itemList.appendChild(nameLi);
				}
				
				
				new jazz.ui.HoverPopup({ around: [ tabLink ], html: tipSpan.innerHTML});
				li.appendChild(itemList);

				
				return li;
			},
		_isAjaxModule: function() {
			return window.location.href.indexOf("_ajax-modules") > 0;
		},
		_handleSummaryItemClick: function(e) {

		},
        _markDirtyIfDifferent: function(){
        
        
        },
        
        //
        // Part API Metnods
        //
        setReadOnly: function(isReadOnly){
        },
        getFormElementValues: function(formElements){
        },
        setFormElementValues: function(retainedState){
        },
        /*
         * Add values to the updateLinks commands
         *
         */
        getSaveCommands: function(allCommands){
            return allCommands;
        },
        getValue: function(){
        
        }
    });
    
})();
