/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.SubscribersPart");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil");

dojo.require("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
/*
 * Shows subscribers and can be extended to show any attribute as a list in a section
 */
(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
var EditorUtil	= com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;
var SelectContributorDialog = com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog;
var SUBSCRIBERS_ID= "internalSubscriptions";
var headingColor = "#666668";
var headingNames  = {} 

var columnLayout = {
	name: {
		style: {
			position: "relative",
			left: "0px",
			color: headingColor,
			width: "100%",
			top: "1px"
		}
	}
}

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.SubscribersPart",
	[dijit._Widget, dijit._Templated],
	{
		
		templateString: 
						'<div class="SubscribersPart SectionPart">' +
						'<div dojoAttachPoint="_border" style="margin-left:0.75em; margin-bottom: 0.5em;">' +
						'<div dojoAttachPoint="_hr" style="color:#003955;font-weight:bold;background-color:#F3F7F9;display:none;padding-left: 5px;">&nbsp;</div>' +
						'<div dojoAttachPoint="_addDIV" style="position:absolute;top:0;right:0;padding-right:3px; margin-right=3em;display:none" class="AddApproversAnchor"><a dojoAttachPoint="_addCommand" href="#">Add...</a></div>' +
						'<div class="SubscribersContent" dojoAttachPoint="_contentNode">No items.</div>' +
						'</div></div>',
  		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
			columnLayout.name.label = this.messages.labelName;
			headingNames = {
				contributorList: this.messages.labelListOfUsers,
				processAreaList: this.messages.labelListOfProcessAreas,// "Process Areas",
				projectAreaList: this.messages.labelListOfProjectAreas, //"Project Areas"
				subscriptions: this.messages.labelListOfSubscribers, //"Subscribers"
				teamAreaList: this.messages.labelListOfTeamAreas, // "Team Areas",
				workItemList: this.messages.labelListOfWorkItems //  "Work Items"
			}
		},	
		postCreate: function() {	
		// this.parentController is the work item editor
			this._childWidgets = [];
			this._isInitialized = false;
			this._workItem = this.parentController._workItem;

			if(!this.workingCopy.isGuest()) {
				if(this.sectionLayout && (!this.sectionLayout._childWidgets || this.sectionLayout._childWidgets.length ==0)) {
					this._addSubscriberAction = this.sectionLayout.addActionText(this.messages.buttonAddPrompt, 
						this, "_handleNewItemPressed", this.messages.titleItemsAdd);
					this._border.style.marginLeft="0";
					this.connect(this._addSubscriberAction, "onkeypress", "checkEnterForNewItem");
				} else {
					this._hr.style.display="";
					this._addDIV.style.display="";
					this._border.style.border="1px #C7DCE7 solid";  //TODO: move to class, template too
					this.connect(this._addCommand, "onclick", this._handleNewItemPressed2);
					if(this.presentation && headingNames[this.presentation.attributeType]) {
						dojox.data.dom.replaceChildren(this._hr, document.createTextNode(headingNames[this.presentation.attributeType]));	
					}
				}
			}
			this.workingCopy.addListener({
				path: ["attributes", this.attributeId],
				event: "onchange",
				listener: this,
				functionName: "_handleWorkingCopyChange"
			});	
			this.refresh();
		},
		destroyWidget: function() {
			this.destroyChildWidgets();
		},
		destroyChildWidgets: function() {
			for (var i = 0; i < this._childWidgets.length; i++) {
				if (this._childWidgets[i].destroyWidget) {
					this._childWidgets[i].destroyWidget();
					this._childWidgets[i] = null;
				}
				else {
					if (this._childWidgets[i].destroy) 
						this._childWidgets[i].destroy();
					this._childWidgets[i] = null;
				}
			}

			this._childWidgets = [];
			dojox.data.dom.removeChildren(this._contentNode);
		},
		/*
		 * Load the tab when it is shown
		 */
		showWidget: function() {
			if(this._isInitialized) return;
			this._isInitialized = true;
			this.refresh();
		},
		_handleWorkingCopyChange: function() {
			this.refresh();
		},
		/*
		 * Setup the page and read the states and types 
		 */
		refresh: function() {

			this.destroyChildWidgets();			
			this._markDirtyIfDifferent();
			var creationArgs = {
						parentWidget: this,
						parentController: this.parentController,
						isHeading: false,
						isFirst: false,
						tableClass: "SectionListTableNoBorder"
					};
			var listWidget = new com.ibm.team.workitem.web.ui.internal.view.layout.SectionListWidget(creationArgs);
			
			var rowItems = [];
			var subscribers = this.workingCopy.getItems({attributeId: this.attributeId});
			
			subscribers.sort(function(a, b){
				try {
					return a.name.toLowerCase() < b.name.toLowerCase() ? -1 : 1;
				} 
				catch (e) {
					return -1
				}
			});
			
			for (var i = 0; i < subscribers.length; i++) {
				if (subscribers[i]) {
					var item = {};
					item.columnWidgets = [this._getRow(listWidget, subscribers[i], /* noBorder */ true, /* isLast withborder */ false) ]
					item.noBorder = true ;
					item.value  = subscribers[i];
					item.showDelete = true;
					rowItems.push(item);
				}
			}

		
			listWidget.setRows(
					{
						itemList: rowItems,
						  deleteAction: {
								selector: "_handleDeleteSubscriber",
								title: this.messages.titleItemRemove
						},
 						restoreAction: {
								selector: "_handleRestoreSubscriber",
								title: this.messages.titleItemRestore
						}
					}
					)
			dojox.data.dom.removeChildren(this._contentNode);					
			if(subscribers.length > 0) {
				this._contentNode.appendChild(listWidget.domNode);
				this._childWidgets.push(listWidget);			
			} else {
				var span = document.createElement("SPAN");
				span.style.color = "#999999"; // TODO: move to class
				span.style.paddingLeft = "5px";				
				if(!this.presentation) {
					span.appendChild(document.createTextNode(this.messages.labelListNoItemsDefault));
				} else {
					var typeName = headingNames[this.presentation.attributeType] || this.messages.labelListOfItems;
					span.appendChild(document.createTextNode(dojo.string.substitute(this.messages.labelListNoItems, [typeName])));
				}
				this._contentNode.appendChild(span);
			}

		},
		_markDirtyIfDifferent: function() {
			if(this.workingCopy.isChanged()) {
				if(this.parentWidget && this.parentWidget.markDirty) {
					this.parentWidget.markDirty();
				} 
				if(this.parentWidget && this.parentWidget.parentController && this.parentWidget.parentController.markDirty) {
						this.parentWidget.parentController.markDirty();
				}
			}
		},
		_handleDeleteSubscriber: function(e) {
			
			if(e && e.target && e.target.parentWidget && e.target.parentWidget.deleteSubscriber) {
				e.target.parentWidget.deleteSubscriber(e.target.value);
			}		
			
		},
		deleteSubscriber:function(subscriber) {
			this.workingCopy.deleteItems({
				items: [subscriber],
				attributeId: this.attributeId
			});
			this.refresh();
		},
		_handleRestoreSubscriber: function(e) {
			if (e && e.target && e.target.parentWidget && e.target.parentWidget.restoreSubscriber) {
				e.target.parentWidget.restoreSubscriber(e.target.value);
			}
		},
		restoreSubscriber:function(subscriber) {
			this.workingCopy.restoreItems({
				items: [subscriber],
				attributeId: this.attributeId
			});
			this.refresh();
		},
		_getRow: function(listWidget, subscriber, noBorder , isLast) {
			var layout = WidgetUtil.mergeObjects({}, columnLayout.name);
			subscriber.name = this._getItemLabel(subscriber);
			var split = subscriber.name.split(" ");
			var name = "";
			for(var i=0;i<split.length;i++) {
				var word = split[i];
				if(word.length> 16) {
					word = word.replace(/.{15}/g,"$& ");
				}
				name += " " + word;
			}
			
			name.replace(/  /g," ");
			layout.label = name;
			layout.isFirst = noBorder;
			layout.isLast = isLast;
			if(subscriber.emailAddress) {
				var emailSubject;
				if(this.parentController && this.parentController.workingCopy) {
					try {
						emailSubject =  this.parentController.workingCopy.object.attributes.workItemType.label + " " + this.parentController.workingCopy.getId() + ": " + EditorUtil.restoreTags(this.parentController.workingCopy.object.attributes.summary.content);
					}	catch(e) {} // ignore;			
				}
				layout.href = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil._getMailto(subscriber.emailAddress, emailSubject); // subject can be null
			} else {
				if(this._getItemHref) {
					var href = this._getItemHref(subscriber);
					if(href) layout.href = href;
				}
			}
			var widget =listWidget.getLabelWidget(layout);
			if(subscriber.userId) {
				widget.domNode.title= name + " (@" + subscriber.userId + ")";
			}
			
			if(noBorder) widget.columnParms = { className: "SectionListTableHeaderNoBorder" } 
			return widget;
		},
		_getItemLabel: function(item) {
			return item.name || item.label || this.messages.labelUnknown;
		},
		addSubscribers: function(newContribs) {
			this.workingCopy.addItems({
				items: newContribs,
				attributeId: this.attributeId
			});
			this.refresh();
		},
		
		checkEnterForNewItem: function(e) {
			var characterCode;
			characterCode = e.keyCode;
			if(characterCode == 13) { //the key presed was 'enter'
				this._handleNewItemPressed2(e);			
			}	
		},

		_handleNewItemPressed2: function(e) {
			e.preventDefault();
			this._openCustomChooseDialog();
		},
		_handleNewItemPressed: function(action) {
			this._openCustomChooseDialog();
		},		
		_openCustomChooseDialog: function() {
			if(this._openChooseDialog) {
				this._openChooseDialog()
			} else {
				this._openSubscribersDialog();
			}
		},
		_openSubscribersDialog: function() {
			var self= this;

				var params= {
					disableUsers: this.getCurrentItems()
				};
				

			this.contributorListWidget= new SelectContributorDialog(params);
			this.connect(this.contributorListWidget, "onClose", dojo.hitch(this, function() { this.parentController.focus();}));
			this.connect(this.contributorListWidget, "onOK", dojo.hitch(this, function(selectedContribs) { this.addSubscribers(selectedContribs);}));
			this.contributorListWidget.searchText.focus();				
		},
		/**
		 * Returns an array of the itemIds of the current subscribers.
		 */
		getCurrentItems: function() {
			return this.workingCopy.getCurrentItems({attributeId: this.attributeId, includeCreator: false});
		}
	}
);

})();
