/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.layout.NameValueLayout");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");
	
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");

(function() {

var checkNotNull=	net.jazz.ajax.toolbox.lang.checkNotNull;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.layout.NameValueLayout",
	[dijit._Widget, dijit._Templated], 
	{
	templateString: '<div class="com-ibm-team-workitem-view-layout-NameValueLayout">'
		+ '<table CELLPADDING="0" CELLSPACING=0 dojoAttachPoint="_nameValueTable" class="com-ibm-team-workitem-namevalue-table">'
		+ '</table></div>',
	postCreate: function() {
		// hasRequiredMarker
		this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
		this.inherited(arguments);
	},
	addRow: function(labelText, valueNode, isRequired ) {
		var row = this._nameValueTable.insertRow(-1);
		row.className = "com-ibm-team-workitem-namevalue-tr";
		
		var labelCol = row.insertCell(-1);
		labelCol.className = "com-ibm-team-workitem-namevalue-label-td";
		var labelSpan = document.createElement("div");
		labelSpan.className = "com-ibm-team-workitem-namevalue-label-node";
		if(labelText && labelText.indexOf(":") == -1) labelText += ":";
		labelSpan.appendChild(document.createTextNode(labelText || "" ));
		labelCol.appendChild(labelSpan);
		
		if(this.hasRequiredMarker && isRequired != null) {
			var reqCol = row.insertCell(-1);
			reqCol.className = "com-ibm-team-workitem-namevalue-required-td";
			reqCol.appendChild(this._getRequiredMarkerElement(isRequired));
		}	
		
		var valueCol = row.insertCell(-1);
		valueCol.className = "com-ibm-team-workitem-namevalue-value-td";
		valueCol.appendChild(valueNode);
	},
	addSeparatorRow: function() {
		var row = this._nameValueTable.insertRow(-1);
		row.className = "com-ibm-team-workitem-namevalue-tr-sep";
		var labelCol = row.insertCell(-1);
		labelCol.appendChild(this._getSeparatorElement());
		if(this.hasRequiredMarker) {
			var reqCol = row.insertCell(-1);
			reqCol.appendChild(this._getSeparatorElement());
		}
		var valueCol = row.insertCell(-1);
		valueCol.appendChild(this._getSeparatorElement());
	},
	_getSeparatorElement: function() {
		var span = document.createElement("span");
		span.className = "com-ibm-team-workitem-namevalue-value-td-sep";
		return span;
	},
	_getRequiredMarkerElement: function(isRequired) {
		var requiredMarkerSpan = document.createElement("span");
		requiredMarkerSpan.innerHTML = this.messages.labelRequired; // "* " innerHTML OK 
		requiredMarkerSpan.title = this.messages.titleRequiredMarker;
		if(isRequired) { 
				requiredMarkerSpan.style.visibility = "visible";
			} else {
				requiredMarkerSpan.style.visibility = "hidden";
			}
		return requiredMarkerSpan;	
	}
});
	
})();