/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.PlanToolBar"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dojox.data.dom"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.Actions"); //$NON-NLS-1$

(function() {

var Assert					= com.ibm.team.apt.web.ui.internal.common.Assert;
var Actions					= com.ibm.team.apt.web.ui.internal.view.plan.actions.Actions;

var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.PlanToolBar", //$NON-NLS-1$
			 [dijit._Widget, dijit._Templated], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	_tabPlannedItems: null,
	_viewModel: null,
	_viewer: null,
	
	/* div to attach commands to */
	_toolBarCommands: null,
	
	_editAction: null,
	
	// ---- api ------------------------------------------------------------------------------------------------------------

	// ---- widget implementation ------------------------------------------------------------------------------------------

	templatePath: dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/templates/PlanToolBar.html"), //$NON-NLS-1$ //$NON-NLS-2$
	
	postCreate: function() {
		this._editAction= this.__createAction(MSGS.PLANNEDITEMS_PLAN_TOOL_BAR_ACTION_EDIT, "edit", this._toolBarCommands); //$NON-NLS-1$
		this.connect(this._editAction, "onclick", "__onEditButton"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------
	
	__onEditButton: function(event) {
		dojo.stopEvent(event);
		
		var isChecked= this.__toggleCheck(this._editAction);
		this._viewer.enableEditMode(isChecked);
	},
	
	__createAction: function(label, style, parentNode) {
		var container=document.createElement("a"); //$NON-NLS-1$
		dojo.addClass(container, "command"); //$NON-NLS-1$
		dojo.addClass(container, style);
		container.setAttribute("checked", "false"); //$NON-NLS-1$ //$NON-NLS-2$
		container.setAttribute("title", label); //$NON-NLS-1$
		
		//Make the child of the link a real image so that we can pick up it's alt text when images are off
		var image = document.createElement("img"); //$NON-NLS-1$
		image.src = dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/transparent.gif"); //$NON-NLS-1$ //$NON-NLS-2$
		image.alt = label;
		container.appendChild(image);
		
		parentNode.appendChild(container);
		return container;
	},
	
	__toggleCheck: function(action) {
		var checked= action.getAttribute("checked"); //$NON-NLS-1$
		if (checked == "true") { //$NON-NLS-1$
			action.setAttribute("checked", "false"); //$NON-NLS-1$ //$NON-NLS-2$
			return false;
		} else {
			action.setAttribute("checked", "true"); //$NON-NLS-1$ //$NON-NLS-2$
			return true;
		}
	},

	__sentinel: null // terminates this class definition
});

/**
 * This helper method creates the arguments object for the widget's constructor.
 * @return {Object} a widget private object to be passed in as a constructor argument
 */
com.ibm.team.apt.web.ui.internal.view.plan.PlanToolBar.constructorArgs= function(tabPlannedItems, viewModel, viewModelViewer) {
	return {
		_tabPlannedItems: tabPlannedItems,
		_viewModel: viewModel,
		_viewer: viewModelViewer
	};
};

})();
