/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.EditAction"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$=

(function() {

var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var IconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/edit.gif"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.EditAction", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.actions.Action], {
	
	_viewerItem: null,
	
	constructor: function(viewerItem) {
		this._viewerItem= viewerItem;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getId: function() {
		return "edit.planItem"; //$NON-NLS-1$
	},
	
	getName: function() {
		return MSGS.ACTION_EDIT;
	},
	
	getIconUrl: function() {
		return IconUrl;
	},
	
	canHandle: function(target, selection) {
		return this._viewerItem instanceof com.ibm.team.apt.web.ui.internal.view.plan.planneditems.PlanItemViewerItem && !this._viewerItem.isEditorOpen();
	},
	
	handle: function(targetEntry, selection) {
		this._viewerItem.toggleEdit();
	},
	
	// --- implementation ------------------------------------
	
	__sentinel: null // terminates this class definition
});

})();
