/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.MoveAboveAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.SaveRunnerExecuteAction"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$=

dojo.require("dojo.string"); //$NON-NLS-1$

(function() {
	
var Assert							= com.ibm.team.apt.web.ui.internal.common.Assert;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var bind= dojo.string.substitute;

var IconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/add_item_above.gif"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.MoveAboveAction", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.actions.SaveRunnerExecuteAction], {
	
	_viewModel: null,
	_errorReporter: null,
	_movePolicy: null,
	
	constructor: function(viewModel, itemMovePolicy, errorReporter) {
		this._viewModel= viewModel;
		this._movePolicy= itemMovePolicy;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getId: function() {
		return "move.above"; //$NON-NLS-1$
	},
	
	getName: function(targetEntry, selection) {
		if (selection.length != 1)
			return MSGS.ACTION_MOVE_ELEMENT_ABOVE;
		
		var sourceElement= selection[0].getElement();
		if (!(sourceElement instanceof com.ibm.team.apt.client.PlanItem))
			return MSGS.ACTION_MOVE_ELEMENT_ABOVE;
		
		var targetElement= targetEntry.getElement();
		if (!(targetElement instanceof com.ibm.team.apt.client.PlanItem))
			return MSGS.ACTION_MOVE_ELEMENT_ABOVE;
		
		return bind(MSGS.ACTION_MOVE_ELEMENT_ABOVE_2, [sourceElement.getId(), targetElement.getId()]);
	},
	
	getIconUrl: function() {
		return IconUrl;
	},
	
	canHandle: function(targetEntry, selection) {
		if (selection.length != 1)
			return false;
		
		return this._movePolicy.canMove(selection[0], targetEntry, com.ibm.team.apt.ui.Move.Before);
	},
	
	_doHandle: function(targetEntry, selection) {
		return this._movePolicy.move(selection[0], targetEntry, com.ibm.team.apt.ui.Move.Before);
	},
	
	// --- implementation ------------------------------------
	
	__sentinel: null // terminates this class definition
});

})();
