/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.QuickFilterAction"); //$NON-NLS-1$

dojo.require("dijit.Menu"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.MenuAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.TogglePlanFilterAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.ToolBarManager"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {

var ToolBarManager= com.ibm.team.apt.web.ui.internal.view.plan.actions.ToolBarManager;
var TogglePlanFilterAction= com.ibm.team.apt.web.ui.internal.view.plan.actions.TogglePlanFilterAction;

var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var IconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/filter.gif"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.QuickFilterAction", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.actions.MenuAction], {

	_tabPlannedItems: null,
	_menu: null,
	
	constructor: function(tabPlannedItems) {
		this._tabPlannedItems= tabPlannedItems;
	},
	
	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getId: function() {
		return "plan.quickFilter"; //$NON-NLS-1$
	},
	
	getName: function() {
		return MSGS.ACTION_QUICK_FILTER;
	},
	
	getIconUrl: function() {
		return IconUrl;
	},
	
	createActions: function(lazyCreationCallback) {
		if(!this._tabPlannedItems.getConfigurationElements()) {
			this._tabPlannedItems.loadConfigurationElements(dojo.hitch(this, function() {
				lazyCreationCallback(this.__createActions());
			}));
			return [];
		} else {
			return this.__createActions();
		}
	},
		
	canHandle: function() {
		return !this._tabPlannedItems.isPlanModeEdit();
	},
	
	// ----- Implementation ---------------------------
	
	__createActions: function() {
		var result= new Array();
		dojo.forEach(this._tabPlannedItems.getConfigurationElements().filters, function(filter) {
			result.push(new TogglePlanFilterAction(this._tabPlannedItems, filter));
		}, this);
		return result;
	},
	
	__sentinel: null // terminates this class definition
});

})();
