/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.OperationConditionSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("jazz.core.internal.loader");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.ConditionSection");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.ListWidget");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages");
(function(){

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.OperationConditionSection", com.ibm.team.workitem.web.ui.internal.view.queryeditor.ConditionSection, {
	_createWidget: function(/* PresentationDTO */ presentation) {
		
		if (!presentation) {
			this._hideLoadingMessage();
			return;
		}
		
		presentation.isOperationAssignment = true;	
		var site= this._site;
		var operator= this.expression ? this.expression.operator : presentation.operators[0];
		this._setOperator(operator);
		
		site.setTitle(presentation.attribute.label);
//		site.setupMenu("label", dojo.hitch(this, this._handleSetOperator));
//		site.setMenuItems(presentation.operators);
//		site.setSelectedMenuItem(operator);
		
//		this._createVariableControls(presentation.variables, this.expression ? this.expression.variables : []);
		
		this._loadWidget(presentation);
	},
	handleRowSelectionChanged: function(selectedRows) {
		if(!this._presentationWidget) return null;
		if(this._presentationWidget.handleRowSelectionChanged) { // ListWidget
			this._presentationWidget.handleRowSelectionChanged(selectedRows);
		}		
	},
	/* { id: x, value: y } */ getOperation: function() {
		if(!this._presentationWidget) return null;
		var values =  this._presentationWidget.getValues();
		if(this.attributeId == "internalState") {
			var id = "workflowAction";
			var isWorkFlowAction = true;
		} else {
			var isWorkFlowAction = false;
			var id = this.attributeId
		}
		var id = this.attributeId == "internalState" ? "workflowAction" : this.attributeId;
		if (values.length > 0) {
			return {
				isAction: isWorkFlowAction,
				id: id,
				value: values[0]
			}
		}
		return null;
	}
	
});
	
})();
