/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

dojo.provide("com.ibm.rational.cm.web.ui.utils.RecordChooser");

dojo.require("com.ibm.rational.cm.web._base");
dojo.require("com.ibm.rational.cm.web.ui.page.CqLoginController");

(function(){

var _defaultRecordType, _columnInfo;
var cq = com.ibm.rational.cm.web;
var BASE_URL = "cqartifactdetails.cq";
	
/*
 * Opens "Search and Select Records dialog
 * argument is a object which takes the following format
 * {
 * 	title: "Dialog title",
 * 	recordType: "",
 * 	columnInfo: [...],
 * 	onOk: function(selected, colInfo){...},
 * 	multiSelect: true/false
 * }
 */
var _selectDialog;
com.ibm.rational.cm.openRecordChooser = function(obj){
	// call loginController#process so that it checks for login before dialog is being showed
	com.ibm.rational.cm.cqLoginController.process({
		callback: function(){
			cq.loadModule("com.ibm.rational.cm.web.ui.view.resultset.ResultSetDialogContent", function(){

				// create dialog
				var content;
				if(!_selectDialog){
					dojo["require"]("com.ibm.rational.cm.web.ui.view.common.ButtonDialog");
					_selectDialog = new com.ibm.rational.cm.web.ui.view.common.ButtonDialog();
		
					content = new com.ibm.rational.cm.web.ui.view.resultset.ResultSetDialogContent({
						parentDialog: _selectDialog
					});
					_selectDialog.setContent(content);

					// enable/disable OK button depending on number of selected rows
					_selectDialog.connect(content, "onSelectionChanged", function(arr){
						_selectDialog.setOkEnabled((arr.length > 0));
					});

					// show spinner icon when executing query
					_selectDialog.connect(content, "setLoading", "setLoading");

					_selectDialog.resize({ w: 600, h: 500 });
					_selectDialog.startup();
				}else{
					content = _selectDialog.getContent();
				}
		
				// set title
				var title = obj.title;
				if(!title || title.length === 0){
					title = content.messages.searchSelectRecord;
				}
				_selectDialog.setTitle(title);

				// recordType
				dojo["require"]("com.ibm.rational.cm.web.ui.page.RecordTypeManager");
				content.setRecordType(obj.recordType);

				// columnInfo
				var columnInfo = obj.columnInfo;
				if(columnInfo && dojo.isArray(columnInfo)){
					content.columnInfo = columnInfo;
				}else{
					content.columnInfo = [];
				}

				// onOk
				_selectDialog.execute = dojo.hitch(this, function(formContents){
					var onOk = obj.onOk;
					if(!onOk || !dojo.isFunction(onOk)){ return; }
			
					// call callback function
					onOk(content.getValues(), content.columnInfo);
				});
		
				// multiSelect
				content.multiSelect = (obj.multiSelect);
		
				// initialize on show
				content.updateDisplay(false);
				_selectDialog.setOkEnabled(false); // set disabled
		
				_selectDialog.show();
			});
		}
	});
}

})();