/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */
 
dojo.provide("com.ibm.rational.cm.web.ui.view.filter.CqChoiceManager");

(function(){
dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("com.ibm.rational.cm.web._base.xhr");
dojo.requireLocalization("com.ibm.rational.cm.web.ui","cqQuery");
var cq = com.ibm.rational.cm.web;

dojo.declare(
	"com.ibm.rational.cm.web.ui.view.filter.CqChoiceManager",
	dijit._Widget,
{
	postMixInProperties: function(){
		this.i18nStrings = dojo.i18n.getLocalization("com.ibm.rational.cm.web.ui", "cqQuery", this.lang);
		this._choiceListInfo = {};
		this.inherited(arguments);
	},
	
	fetchChoiceList: function(message){
		if(!message){ return; }
		var resourceId = message.resourceId;
		if(!resourceId || resourceId.length === 0){ return; }
		if(!this._choiceListInfo[resourceId]){
			this._choiceListInfo[resourceId] = {};
		}
		if(this._choiceListInfo[resourceId].list || this._choiceListInfo[resourceId].isLoading){ return; }
		this._choiceListInfo[resourceId].isLoading = true;
		var content = {
			action: "GetValueList",
			fieldId: resourceId
		};
		var i18nStrings = this.i18nStrings;
		var self = this;
		cq.xhrGet({
			url: "cqquerywizard.cq",
			content: content,
			load: function(response, ioArgs){
				if(response.status && response.status == "ok"){
					self._choiceListInfo[resourceId].list = response.data;
					self.onChoiceLoaded(resourceId);
				}else if(response.status && response.status == "error"){
					alert(i18nStrings.msg_valuelist_error+": " + response.message);
				}else{
					alert(i18nStrings.query_creation_unknown_response_format);
				}
			},
			error: function(response, ioArgs){
				alert(i18nStrings.msg_valuelist_error);
			},
			handle: function(response, ioArgs){
				self._choiceListInfo[resourceId].isLoading = false;
			},
			onCancel: dojo.hitch(this, "onChoiceCancel"),
			handleError: true,
			preventCache: true
		}); 
	},
	
	// stub function that can be connected
	onChoiceLoaded: function(resourceId){},
	
	onChoiceCancel: function(){},

	getChoiceListInfo: function(resourceId, propName){
		var info = this._choiceListInfo[resourceId];
		if(info[propName]){
			return info[propName];
		}
		return null;
	}
});

})();

com.ibm.rational.cm.web.ui.view.filter.choiceManager = new com.ibm.rational.cm.web.ui.view.filter.CqChoiceManager();