/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest
 * (C) Copyright IBM Corp. 2007, 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */
dojo.provide("com.ibm.rational.cm.web.ui.view.report.LinkedContentView");

dojo.require("dojo.string");
dojo.require("dojo.i18n");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit._Templated");
dojo.require("dijit.Toolbar");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.rational.cm.web._base");

dojo.requireLocalization("com.ibm.rational.cm.web.ui", "common");
dojo.requireLocalization("com.ibm.rational.cm.web.ui", "ResultSetMessages");
dojo.requireLocalization("com.ibm.rational.cm.web.ui", "cqRecordStrings");

(function(){

    var cq = com.ibm.rational.cm.web;
    var cqNS = "com.ibm.rational.cm.web.ui";
    
    dojo.declare("com.ibm.rational.cm.web.ui.view.report.LinkedContentView", [dijit.layout.BorderContainer, dijit._Templated], {
        templatePath: dojo.moduleUrl("com.ibm.rational.cm.web", "ui/view/report/templates/LinkedContentView.html"),
        
        title: "",
		type: "",
		type: null,
		widgetsInTemplate: true,
		contentWidget: null,
		widgetType: "LinkedContentView",
        
        
        postMixInProperties: function(){
            var getLoc = dojo.i18n.getLocalization;
            var lang = this.lang;
            this.messages = getLoc(cqNS, "ResultSetMessages", lang);
            this.inherited(arguments);
        },
        
        postCreate: function(){
            this.inherited(arguments);
            this.setTitleCell(this.title);
            
        },
        
        // a stub function that can be connected
        setLoading: function(/* boolean */loading, /* String */ message){
        },
		
		/* Hold onto the wrapper for the content node */
		setContentWidget: function(/* Widget */ widget) {
			this.contentWidget = widget;
			this.addContent(widget.domNode);
		},		
        
        
        startup: function(){
            this.inherited(arguments);
        },
        
        
        // RATLC01062034 : Long text in Full-Text Search will obscure the header of the result column
        setTitleCell: function(title){
            this.titleCell.innerHTML = cq.sanitizeString(title);
            this.titleCell.title = title;
        },
        
        refresh: function(e){
            dojo.publish("CQ_QUERY_EXECUTE", [{
                id: this.id,
                title: this.title,
                type: this.type
            }]);   
        },
		
		addContent: function(node){
			this.contentNode.appendChild(node);
		},
		
		/*
		 * Changing the src attribute of the IMG tag causes a server request to rebuild the chart  
		 */
		refreshChartContent: function(newContent){
			var currentContent = this.contentNode.lastChild;
			currentContent.src = newContent.src;
		},
		
		/* Rerun the report.  The code causes the source URL to be rebuilt
		 * and updated in the DOM node. 
		 */
		refreshReportContent: function(message){
			com.ibm.rational.cm.web.ui.view.report.util.executeReport(this.contentWidget,message);
		},
        
        // RCM
        addToFavorites: function(){
            dojo["require"]("com.ibm.rational.cm.web.ui.page.FavoritesController");
            com.ibm.rational.cm.favoritesController.addFavorite({
                type: this.type,
                title: this.title,
                stableLocation: this.id,
                masterReplica: "<local>" // TODO : hard-coded
            });
        }
    });
    
})();
