/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

dojo.provide("com.ibm.rational.cm.web.ui.view.resultset.actions.exportGrid");

dojo.require("dojo.io.iframe");
dojo.require("com.ibm.rational.cm.web._base");

com.ibm.rational.cm.web.ui.view.resultset.actions.exportGrid = function(/* com.ibm.rational.cm.web.ui.view.resultset.ResultSetView */ widget, menuItem){
	// RATLC01363645 : [Falcon][FVT][MUSTFIX]: Several operations didn't bring up login dialog for re-authentication after session time out
	// call Ping before actually calling export action, so that re-authentication dialog is shown when session timeout
	var cq = com.ibm.rational.cm.web;
	cq.xhrGet({
		url: "cqlogin.cq?action=Ping",
		load: function(response, ioArgs){
			// construct request URL
			var grid = widget.rsGrid;
			var fileFormat = menuItem.fileFormat;
			if(!fileFormat){ // when button is clicked
				fileFormat = "FILE";
			}
			var content = grid.getXhrContent(true);
			var url = com.ibm.rational.cm.web.convertUrl(grid.baseUrl) + "?action=ExportQueryResult&format="+fileFormat;
			for(var key in content){
				url += "&" + key + "=" + encodeURIComponent(content[key]);
			}

			// actually send request
			widget.setLoading(true, dojo.string.substitute(widget.messages.exportingResults, [widget.title] ));
			dojo.io.iframe.send({
    			url: url,
				handle: function(response, ioArgs){
					widget.setLoading(false);
				},
			    timeout: 10 // without this, request won't be send after the first time
  			});
		},
		handleError: true,
		preventCache: true
	});
}