/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.PlanningAttributeType"); //$NON-NLS-1$

dojo.require("com.ibm.team.workitem.common.Attribute"); //$NON-NLS-1$

(function() {

var TYPE_STRING= "STRING"; //$NON-NLS-1$
var TYPE_HTML= "HTML"; //$NON-NLS-1$
var TYPE_INTEGER= "INTEGER"; //$NON-NLS-1$
var TYPE_FLOAT= "FLOAT"; //$NON-NLS-1$
var TYPE_BOOLEAN= "BOOLEAN"; //$NON-NLS-1$
var TYPE_INSTANT= "INSTANT"; //$NON-NLS-1$
var TYPE_DURATION= "DURATION"; //$NON-NLS-1$
var TYPE_TIMESPAN= "TIMESPAN"; //$NON-NLS-1$
var TYPE_TAGS= "TAGS"; //$NON-NLS-1$
var TYPE_SEQUENCEVALUE= "SEQUENCEVALUE"; //$NON-NLS-1$
var TYPE_RANKING= "RANKING"; //$NON-NLS-1$
var TYPE_CHECKERREPORT= "CHECKERREPORT"; //$NON-NLS-1$
var TYPE_UUID= "UUID"; //$NON-NLS-1$
var TYPE_WORKITEM_TYPE= "TYPE"; //$NON-NLS-1$
var TYPE_WORKFLOW_STATE= "STATE"; //$NON-NLS-1$
var TYPE_ITEM= "ITEM"; //$NON-NLS-1$
var TYPE_ENUMERATION= "ENUMERATION"; //$NON-NLS-1$
var TYPE_VOID= "VOID"; //$NON-NLS-1$

function primitiveComparator(v1, v2) { return v1 < v2 ? -1 : (v1 > v2 ? 1 : 0); }
function comparableComparator(v1, v2) { return v1.compareTo(v2); }
function primitiveEquals(v1, v2) { return v1 == v2; }
function itemEquals(v1, v2) { return v1.itemId == v2.itemId && v1.itemType == v2.itemType; }
function equalsEquals(v1, v2) { return v1.equals(v2); }
function unsupportedOperation(v1, v2) { throw new Error("Unsupported Operation"); } //$NON-NLS-1$

dojo.declare("com.ibm.team.apt.client.PlanningAttributeType", null, { //$NON-NLS-1$

	constructor: function(id, comparator, equals) {
		this.__id= id;
		this.__comparator = comparator;
		this.__equals = equals;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	compareValues: function(v1, v2) {
		if (v1 === undefined || v2 === undefined)
			return (v1 === undefined ? 1 : 0) - (v2 === undefined ? 1 : 0);

		if (v1 === null || v2 === null)
			return (v1 === null ? 1 : 0) - (v2 === null ? 1 : 0);
				
		return this.__comparator(v1, v2);
	},

	equalValues: function(v1, v2) {
		if (v1 === undefined)
			return v2 === undefined;
		
		if (v2 === undefined)
			return v1 === undefined;

		if (v1 === null)
			return v2 === null;
		
		if (v2 === null)
			return v1 === null;

		return this.__equals(v1, v2);
	},

	equals: function(other) {
		if (this === other)
			return true;

		if (this.declaredClass !== other.declaredClass)
			return false;
		
		return this.__id == other.__id;
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

var PlanningAttributeType= com.ibm.team.apt.client.PlanningAttributeType;

PlanningAttributeType.STRING= new PlanningAttributeType(TYPE_STRING, primitiveComparator, primitiveEquals);
PlanningAttributeType.HTML= new PlanningAttributeType(TYPE_HTML, primitiveComparator, primitiveEquals);
PlanningAttributeType.INTEGER= new PlanningAttributeType(TYPE_INTEGER, primitiveComparator, primitiveEquals);
PlanningAttributeType.FLOAT= new PlanningAttributeType(TYPE_FLOAT, primitiveComparator, primitiveEquals);
PlanningAttributeType.BOOLEAN= new PlanningAttributeType(TYPE_BOOLEAN, primitiveComparator, primitiveEquals);
PlanningAttributeType.INSTANT= new PlanningAttributeType(TYPE_INSTANT, comparableComparator, equalsEquals);
PlanningAttributeType.DURATION= new PlanningAttributeType(TYPE_DURATION, comparableComparator, equalsEquals);
PlanningAttributeType.TIMESPAN= new PlanningAttributeType(TYPE_TIMESPAN, comparableComparator, equalsEquals);
PlanningAttributeType.TAGS= new PlanningAttributeType(TYPE_TAGS, unsupportedOperation, primitiveEquals);
PlanningAttributeType.SEQUENCEVALUE= new PlanningAttributeType(TYPE_SEQUENCEVALUE, comparableComparator, equalsEquals);
PlanningAttributeType.RANKING= new PlanningAttributeType(TYPE_RANKING, comparableComparator, equalsEquals);
PlanningAttributeType.CHECKERREPORT= new PlanningAttributeType(TYPE_CHECKERREPORT, unsupportedOperation, equalsEquals);
PlanningAttributeType.UUID= new PlanningAttributeType(TYPE_UUID, unsupportedOperation, primitiveEquals);
PlanningAttributeType.WORKITEM_TYPE= new PlanningAttributeType(TYPE_WORKITEM_TYPE, unsupportedOperation, itemEquals);
PlanningAttributeType.WORKFLOW_STATE= new PlanningAttributeType(TYPE_WORKFLOW_STATE, unsupportedOperation, itemEquals);
PlanningAttributeType.ITEM= new PlanningAttributeType(TYPE_ITEM, unsupportedOperation, itemEquals);
PlanningAttributeType.ENUMERATION= new PlanningAttributeType(TYPE_ENUMERATION, comparableComparator, equalsEquals);
PlanningAttributeType.VOID= new PlanningAttributeType(TYPE_VOID, unsupportedOperation, unsupportedOperation);

})();
