/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.internal.attributes.ReflectiveAttribute"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.client.PlanningAttribute"); //$NON-NLS-1$

(function() {
	
var PlanningAttribute				= com.ibm.team.apt.client.PlanningAttribute;

dojo.declare("com.ibm.team.apt.client.internal.attributes.ReflectiveAttribute", PlanningAttribute, { //$NON-NLS-1$
	
	__getter: null,
	__setter: null,
	
	constructor: function(descriptor, name, getterKind, setterKind, valueSet) {
		this.__getter= getAccessorName(name, getterKind);
		this.__setter= getAccessorName(name, setterKind);
		
		if (valueSet) {
			this.__valueSet= valueSet;
		}
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	hasGetter: function() {
		return this.__getter != null;
	},
	
	getValue: function(receiver) {
		if (this.__getter == null) {
			throw new Error("can't read attribute " + this.getId()); //$NON-NLS-1$
		}
		return receiver[this.__getter] && receiver[this.__getter]();
	},
	
	hasSetter: function() {
		return this.__setter != null;
	},
	
	setValue: function(receiver, value) {
		if (this.__setter == null) {
			throw new Error("can't write attribute " + this.getId()); //$NON-NLS-1$
		}
		receiver[this.__setter](value);
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

var NO_ACCESSOR= "none"; //$NON-NLS-1$

com.ibm.team.apt.client.internal.attributes.ReflectiveAttribute.GetterKind= {
	NONE: NO_ACCESSOR,
	GET: "get", //$NON-NLS-1$
	IS: "is", //$NON-NLS-1$
	HAS: "has" //$NON-NLS-1$
};

com.ibm.team.apt.client.internal.attributes.ReflectiveAttribute.SetterKind= {
	NONE: NO_ACCESSOR,
	SET: "set" //$NON-NLS-1$
};

function getAccessorName(name, accessorPrefix) {
	return accessorPrefix + name.charAt(0).toUpperCase() + name.substring(1);
}

})();
