/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.internal.attributes.UnresolvedWorkItemAttribute"); //$NON-NLS-1$

dojo.require("com.ibm.team.foundation.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.Duration"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.PlanningAttribute"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.PlanningAttributeType"); //$NON-NLS-1$

(function() {

var Assert							= com.ibm.team.foundation.Assert;
var PlanningAttribute				= com.ibm.team.apt.client.PlanningAttribute;
var PlanningAttributeType			= com.ibm.team.apt.client.PlanningAttributeType;

dojo.declare("com.ibm.team.apt.client.internal.attributes.UnresolvedWorkItemAttribute", PlanningAttribute, { //$NON-NLS-1$

	constructor: function(descriptor) {
		this.__value= undefined;
		switch (this.attributeType) {
			case PlanningAttributeType.DURATION:
				this.__value= com.ibm.team.apt.client.Duration.UNSPECIFIED;
				break;
		}
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	getValue: function(receiver) {
		return this.__value;
	},
	
	setValue: function(receiver, newValue) {
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

})();
