/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.tempo.internal.client.simulation.CostCumulativePctDistributionRpt"); //$NON-NLS-1$

dojo.require("com.ibm.team.tempo.internal.client.simulation.ACostDistributionRpt"); //$NON-NLS-1$

(function() {
	
var ACostDistributionRpt			= com.ibm.team.tempo.internal.client.simulation.ACostDistributionRpt;

dojo.declare("com.ibm.team.tempo.internal.client.simulation.CostCumulativePctDistributionRpt", ACostDistributionRpt, { //$NON-NLS-1$

	constructor: function(dist) {
		this.dist = dist;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	/**
	 * Print the distribution to the console.
	 */
	run: function () {
		var title = "Cost Cumulative Probability Distribution Report"; //$NON-NLS-1$
		var midpoint;
		
		this.addHeader(title, "Cumulative Pct", 100); //$NON-NLS-1$
		var cumulativePct = 0.0;
		
		for (var i = 0; i < this.dist.getNrOfBins(); i++) {
			midpoint = this.dist.getMidpointStr(i);
			cumulativePct = cumulativePct + this.dist.getBinPercent(i); 
			this.addDetail(midpoint, cumulativePct, 1);
		}
		
		this.addUnivariateStats();
	},

	
	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});
	
})();
